/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
export interface ConsumeAsyncOptions {
    /** Indicates whether iterated elements should be cached for subsequent iterations. */
    cacheElements?: boolean;
    /** Indicates whether to leave the iterator open when the iterable returns. */
    leaveOpen?: boolean;
}
/**
 * Creates an [[AsyncIterable]] that, when iterated, consumes the provided [[AsyncIterator]].
 *
 * @param iterator An [[AsyncIterator]] object.
 * @category Query
 */
export declare function consumeAsync<T>(iterator: AsyncIterator<T>, { cacheElements, leaveOpen }?: ConsumeAsyncOptions): AsyncIterable<T>;
