"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const internal_1 = require("../internal");
const correspondsByAsync_1 = require("./correspondsByAsync");
const common_1 = require("./common");
function correspondsAsync(left, right, equalityComparison = internal_1.SameValue) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        internal_1.assert.mustBeAsyncQueryable(left, "left");
        internal_1.assert.mustBeAsyncQueryable(right, "right");
        internal_1.assert.mustBeFunction(equalityComparison, "equalityComparison");
        return yield correspondsByAsync_1.correspondsByAsync(left, right, common_1.identity, common_1.identity, equalityComparison);
    });
}
exports.correspondsAsync = correspondsAsync;
