"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/**
 * @module "iterable-query/fn"
 * @preferred
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
// queries
tslib_1.__exportStar(require("./choose"), exports);
tslib_1.__exportStar(require("./chooseAsync"), exports);
tslib_1.__exportStar(require("./consume"), exports);
tslib_1.__exportStar(require("./consumeAsync"), exports);
tslib_1.__exportStar(require("./continuous"), exports);
tslib_1.__exportStar(require("./continuousAsync"), exports);
tslib_1.__exportStar(require("./empty"), exports);
tslib_1.__exportStar(require("./emptyAsync"), exports);
tslib_1.__exportStar(require("./generate"), exports);
tslib_1.__exportStar(require("./generateAsync"), exports);
tslib_1.__exportStar(require("./hierarchy"), exports);
tslib_1.__exportStar(require("./hierarchyAsync"), exports);
tslib_1.__exportStar(require("./if"), exports);
tslib_1.__exportStar(require("./ifAsync"), exports);
tslib_1.__exportStar(require("./conditional"), exports);
tslib_1.__exportStar(require("./conditionalAsync"), exports);
tslib_1.__exportStar(require("./objectKeys"), exports);
tslib_1.__exportStar(require("./objectKeysAsync"), exports);
tslib_1.__exportStar(require("./objectValues"), exports);
tslib_1.__exportStar(require("./objectValuesAsync"), exports);
tslib_1.__exportStar(require("./objectEntries"), exports);
tslib_1.__exportStar(require("./objectEntriesAsync"), exports);
tslib_1.__exportStar(require("./once"), exports);
tslib_1.__exportStar(require("./onceAsync"), exports);
tslib_1.__exportStar(require("./repeat"), exports);
tslib_1.__exportStar(require("./repeatAsync"), exports);
tslib_1.__exportStar(require("./range"), exports);
// subqueries
tslib_1.__exportStar(require("./append"), exports);
tslib_1.__exportStar(require("./appendAsync"), exports);
tslib_1.__exportStar(require("./concat"), exports);
tslib_1.__exportStar(require("./concatAsync"), exports);
tslib_1.__exportStar(require("./defaultIfEmpty"), exports);
tslib_1.__exportStar(require("./defaultIfEmptyAsync"), exports);
tslib_1.__exportStar(require("./distinct"), exports);
tslib_1.__exportStar(require("./distinctAsync"), exports);
tslib_1.__exportStar(require("./do"), exports);
tslib_1.__exportStar(require("./doAsync"), exports);
tslib_1.__exportStar(require("./tap"), exports);
tslib_1.__exportStar(require("./tapAsync"), exports);
tslib_1.__exportStar(require("./except"), exports);
tslib_1.__exportStar(require("./exceptAsync"), exports);
tslib_1.__exportStar(require("./relativeComplement"), exports);
tslib_1.__exportStar(require("./relativeComplementAsync"), exports);
tslib_1.__exportStar(require("./exceptBy"), exports);
tslib_1.__exportStar(require("./exceptByAsync"), exports);
tslib_1.__exportStar(require("./relativeComplementBy"), exports);
tslib_1.__exportStar(require("./relativeComplementByAsync"), exports);
tslib_1.__exportStar(require("./exclude"), exports);
tslib_1.__exportStar(require("./excludeAsync"), exports);
tslib_1.__exportStar(require("./expand"), exports);
tslib_1.__exportStar(require("./expandAsync"), exports);
tslib_1.__exportStar(require("./eval"), exports);
tslib_1.__exportStar(require("./evalAsync"), exports);
tslib_1.__exportStar(require("./filter"), exports);
tslib_1.__exportStar(require("./filterAsync"), exports);
tslib_1.__exportStar(require("./filterBy"), exports);
tslib_1.__exportStar(require("./filterByAsync"), exports);
tslib_1.__exportStar(require("./filterDefined"), exports);
tslib_1.__exportStar(require("./filterDefinedAsync"), exports);
tslib_1.__exportStar(require("./where"), exports);
tslib_1.__exportStar(require("./whereAsync"), exports);
tslib_1.__exportStar(require("./whereBy"), exports);
tslib_1.__exportStar(require("./whereByAsync"), exports);
tslib_1.__exportStar(require("./whereDefined"), exports);
tslib_1.__exportStar(require("./whereDefinedAsync"), exports);
tslib_1.__exportStar(require("./intersect"), exports);
tslib_1.__exportStar(require("./intersectAsync"), exports);
tslib_1.__exportStar(require("./intersectBy"), exports);
tslib_1.__exportStar(require("./intersectByAsync"), exports);
tslib_1.__exportStar(require("./map"), exports);
tslib_1.__exportStar(require("./mapAsync"), exports);
tslib_1.__exportStar(require("./select"), exports);
tslib_1.__exportStar(require("./selectAsync"), exports);
tslib_1.__exportStar(require("./flatMap"), exports);
tslib_1.__exportStar(require("./flatMapAsync"), exports);
tslib_1.__exportStar(require("./selectMany"), exports);
tslib_1.__exportStar(require("./selectManyAsync"), exports);
tslib_1.__exportStar(require("./pageBy"), exports);
tslib_1.__exportStar(require("./pageByAsync"), exports);
tslib_1.__exportStar(require("./patch"), exports);
tslib_1.__exportStar(require("./patchAsync"), exports);
tslib_1.__exportStar(require("./prepend"), exports);
tslib_1.__exportStar(require("./prependAsync"), exports);
tslib_1.__exportStar(require("./reverse"), exports);
tslib_1.__exportStar(require("./reverseAsync"), exports);
tslib_1.__exportStar(require("./skip"), exports);
tslib_1.__exportStar(require("./skipAsync"), exports);
tslib_1.__exportStar(require("./skipRight"), exports);
tslib_1.__exportStar(require("./skipRightAsync"), exports);
tslib_1.__exportStar(require("./skipUntil"), exports);
tslib_1.__exportStar(require("./skipUntilAsync"), exports);
tslib_1.__exportStar(require("./skipWhile"), exports);
tslib_1.__exportStar(require("./skipWhileAsync"), exports);
tslib_1.__exportStar(require("./spanMap"), exports);
tslib_1.__exportStar(require("./spanMapAsync"), exports);
tslib_1.__exportStar(require("./groupBy"), exports);
tslib_1.__exportStar(require("./groupByAsync"), exports);
tslib_1.__exportStar(require("./groupJoin"), exports);
tslib_1.__exportStar(require("./groupJoinAsync"), exports);
tslib_1.__exportStar(require("./join"), exports);
tslib_1.__exportStar(require("./joinAsync"), exports);
tslib_1.__exportStar(require("./fullJoin"), exports);
tslib_1.__exportStar(require("./fullJoinAsync"), exports);
tslib_1.__exportStar(require("./scan"), exports);
tslib_1.__exportStar(require("./scanAsync"), exports);
tslib_1.__exportStar(require("./scanRight"), exports);
tslib_1.__exportStar(require("./scanRightAsync"), exports);
tslib_1.__exportStar(require("./symmetricDifference"), exports);
tslib_1.__exportStar(require("./symmetricDifferenceAsync"), exports);
tslib_1.__exportStar(require("./symmetricDifferenceBy"), exports);
tslib_1.__exportStar(require("./symmetricDifferenceByAsync"), exports);
tslib_1.__exportStar(require("./xor"), exports);
tslib_1.__exportStar(require("./xorAsync"), exports);
tslib_1.__exportStar(require("./xorBy"), exports);
tslib_1.__exportStar(require("./xorByAsync"), exports);
tslib_1.__exportStar(require("./take"), exports);
tslib_1.__exportStar(require("./takeAsync"), exports);
tslib_1.__exportStar(require("./takeRight"), exports);
tslib_1.__exportStar(require("./takeRightAsync"), exports);
tslib_1.__exportStar(require("./takeWhile"), exports);
tslib_1.__exportStar(require("./takeWhileAsync"), exports);
tslib_1.__exportStar(require("./takeUntil"), exports);
tslib_1.__exportStar(require("./takeUntilAsync"), exports);
tslib_1.__exportStar(require("./union"), exports);
tslib_1.__exportStar(require("./unionAsync"), exports);
tslib_1.__exportStar(require("./unionBy"), exports);
tslib_1.__exportStar(require("./unionByAsync"), exports);
tslib_1.__exportStar(require("./zip"), exports);
tslib_1.__exportStar(require("./zipAsync"), exports);
tslib_1.__exportStar(require("./through"), exports);
tslib_1.__exportStar(require("./throughAsync"), exports);
tslib_1.__exportStar(require("./toHierarchy"), exports);
tslib_1.__exportStar(require("./toHierarchyAsync"), exports);
tslib_1.__exportStar(require("./toLookup"), exports);
tslib_1.__exportStar(require("./toLookupAsync"), exports);
tslib_1.__exportStar(require("./orderBy"), exports);
tslib_1.__exportStar(require("./orderByAsync"), exports);
// hierarchy
tslib_1.__exportStar(require("./traversal"), exports);
tslib_1.__exportStar(require("./traversalAsync"), exports);
tslib_1.__exportStar(require("./nthChild"), exports);
tslib_1.__exportStar(require("./nthChildAsync"), exports);
tslib_1.__exportStar(require("./topMost"), exports);
tslib_1.__exportStar(require("./topMostAsync"), exports);
tslib_1.__exportStar(require("./bottomMost"), exports);
tslib_1.__exportStar(require("./bottomMostAsync"), exports);
// scalars
tslib_1.__exportStar(require("./average"), exports);
tslib_1.__exportStar(require("./averageAsync"), exports);
tslib_1.__exportStar(require("./break"), exports);
tslib_1.__exportStar(require("./breakAsync"), exports);
tslib_1.__exportStar(require("./corresponds"), exports);
tslib_1.__exportStar(require("./correspondsAsync"), exports);
tslib_1.__exportStar(require("./correspondsBy"), exports);
tslib_1.__exportStar(require("./correspondsByAsync"), exports);
tslib_1.__exportStar(require("./count"), exports);
tslib_1.__exportStar(require("./countAsync"), exports);
tslib_1.__exportStar(require("./drain"), exports);
tslib_1.__exportStar(require("./drainAsync"), exports);
tslib_1.__exportStar(require("./elementAt"), exports);
tslib_1.__exportStar(require("./elementAtAsync"), exports);
tslib_1.__exportStar(require("./nth"), exports);
tslib_1.__exportStar(require("./nthAsync"), exports);
tslib_1.__exportStar(require("./endsWith"), exports);
tslib_1.__exportStar(require("./endsWithAsync"), exports);
tslib_1.__exportStar(require("./every"), exports);
tslib_1.__exportStar(require("./everyAsync"), exports);
tslib_1.__exportStar(require("./first"), exports);
tslib_1.__exportStar(require("./firstAsync"), exports);
tslib_1.__exportStar(require("./forEach"), exports);
tslib_1.__exportStar(require("./forEachAsync"), exports);
tslib_1.__exportStar(require("./includes"), exports);
tslib_1.__exportStar(require("./includesAsync"), exports);
tslib_1.__exportStar(require("./includesSequence"), exports);
tslib_1.__exportStar(require("./includesSequenceAsync"), exports);
tslib_1.__exportStar(require("./last"), exports);
tslib_1.__exportStar(require("./lastAsync"), exports);
tslib_1.__exportStar(require("./max"), exports);
tslib_1.__exportStar(require("./maxAsync"), exports);
tslib_1.__exportStar(require("./maxBy"), exports);
tslib_1.__exportStar(require("./maxByAsync"), exports);
tslib_1.__exportStar(require("./min"), exports);
tslib_1.__exportStar(require("./minAsync"), exports);
tslib_1.__exportStar(require("./minBy"), exports);
tslib_1.__exportStar(require("./minByAsync"), exports);
tslib_1.__exportStar(require("./reduce"), exports);
tslib_1.__exportStar(require("./reduceAsync"), exports);
tslib_1.__exportStar(require("./reduceRight"), exports);
tslib_1.__exportStar(require("./reduceRightAsync"), exports);
tslib_1.__exportStar(require("./single"), exports);
tslib_1.__exportStar(require("./singleAsync"), exports);
tslib_1.__exportStar(require("./some"), exports);
tslib_1.__exportStar(require("./someAsync"), exports);
tslib_1.__exportStar(require("./span"), exports);
tslib_1.__exportStar(require("./spanAsync"), exports);
tslib_1.__exportStar(require("./startsWith"), exports);
tslib_1.__exportStar(require("./startsWithAsync"), exports);
tslib_1.__exportStar(require("./sum"), exports);
tslib_1.__exportStar(require("./sumAsync"), exports);
tslib_1.__exportStar(require("./toArray"), exports);
tslib_1.__exportStar(require("./toArrayAsync"), exports);
tslib_1.__exportStar(require("./toMap"), exports);
tslib_1.__exportStar(require("./toMapAsync"), exports);
tslib_1.__exportStar(require("./toObject"), exports);
tslib_1.__exportStar(require("./toObjectAsync"), exports);
tslib_1.__exportStar(require("./toSet"), exports);
tslib_1.__exportStar(require("./toSetAsync"), exports);
tslib_1.__exportStar(require("./unzip"), exports);
tslib_1.__exportStar(require("./unzipAsync"), exports);
tslib_1.__exportStar(require("./copyTo"), exports);
tslib_1.__exportStar(require("./copyToAsync"), exports);
// utils
tslib_1.__exportStar(require("./common"), exports);
