/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
import { AsyncQueryable } from "../types";
/**
 * Computes the sum for a series of numbers.
 * NOTE: If any element is not a `number`, this overload will throw.
 *
 * @param source An [[AsyncQueryable]] object.
 * @category Scalar
 */
export declare function sumAsync(source: AsyncQueryable<number>): Promise<number>;
/**
 * Computes the sum for a series of numbers.
 *
 * @param source An [[AsyncQueryable]] object.
 * @param elementSelector A callback used to convert a value in `source` to a number.
 * @category Scalar
 */
export declare function sumAsync<T>(source: AsyncQueryable<T>, elementSelector: (element: T) => number | PromiseLike<number>): Promise<number>;
