"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
const internal_1 = require("../internal");
/**
 * Pass the entire source to the provided callback, returning an [[AsyncQueryable]] from the result.
 *
 * @param source An [[AsyncQueryable]] object.
 * @param callback A callback function.
 * @category Subquery
 */
function throughAsync(source, callback) {
    internal_1.assert.mustBeAsyncQueryable(source, "source");
    internal_1.assert.mustBeFunction(callback, "callback");
    const result = callback(source);
    internal_1.assert.mustBeAsyncQueryable(result);
    return result;
}
exports.throughAsync = throughAsync;
