"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
function append(source, value) {
    internal_1.assert.mustBeQueryable(source, "source");
    return internal_1.FlowHierarchy(new AppendIterable(internal_1.ToIterable(source), value), source);
}
exports.append = append;
var AppendIterable = /** @class */ (function () {
    function AppendIterable(source, value) {
        this._source = source;
        this._value = value;
    }
    AppendIterable.prototype[Symbol.iterator] = function () {
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [5 /*yield**/, tslib_1.__values(this._source)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, this._value];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    };
    AppendIterable = tslib_1.__decorate([
        internal_1.ToStringTag("AppendIterable")
    ], AppendIterable);
    return AppendIterable;
}());
