"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
var prependAsync_1 = require("./prependAsync");
var consumeAsync_1 = require("./consumeAsync");
var emptyAsync_1 = require("./emptyAsync");
var noCacheAndLeaveOpen = { cacheElements: false, leaveOpen: true };
var cacheAndClose = { cacheElements: true, leaveOpen: false };
function breakAsync(source, predicate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var e_1, _a, prefix, iterator, offset, _b, _c, value, result, _d, remaining, e_1_1;
        return tslib_1.__generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    internal_1.assert.mustBeAsyncQueryable(source, "source");
                    internal_1.assert.mustBeFunction(predicate, "predicate");
                    prefix = [];
                    iterator = internal_1.GetAsyncIterator(internal_1.ToPossiblyAsyncIterable(source));
                    offset = 0;
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 9, 10, 15]);
                    _b = tslib_1.__asyncValues(consumeAsync_1.consumeAsync(iterator, noCacheAndLeaveOpen));
                    _e.label = 2;
                case 2: return [4 /*yield*/, _b.next()];
                case 3:
                    if (!(_c = _e.sent(), !_c.done)) return [3 /*break*/, 8];
                    value = _c.value;
                    result = predicate(value, offset++);
                    if (!(typeof result === "boolean")) return [3 /*break*/, 4];
                    _d = result;
                    return [3 /*break*/, 6];
                case 4: return [4 /*yield*/, result];
                case 5:
                    _d = _e.sent();
                    _e.label = 6;
                case 6:
                    if (_d) {
                        remaining = prependAsync_1.prependAsync(consumeAsync_1.consumeAsync(iterator, cacheAndClose), value);
                        return [2 /*return*/, [
                                internal_1.FlowHierarchy(prefix, source),
                                internal_1.FlowHierarchy(remaining, source)
                            ]];
                    }
                    prefix.push(value);
                    _e.label = 7;
                case 7: return [3 /*break*/, 2];
                case 8: return [3 /*break*/, 15];
                case 9:
                    e_1_1 = _e.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 15];
                case 10:
                    _e.trys.push([10, , 13, 14]);
                    if (!(_c && !_c.done && (_a = _b.return))) return [3 /*break*/, 12];
                    return [4 /*yield*/, _a.call(_b)];
                case 11:
                    _e.sent();
                    _e.label = 12;
                case 12: return [3 /*break*/, 14];
                case 13:
                    if (e_1) throw e_1.error;
                    return [7 /*endfinally*/];
                case 14: return [7 /*endfinally*/];
                case 15: return [2 /*return*/, [
                        internal_1.FlowHierarchy(prefix, source),
                        internal_1.FlowHierarchy(emptyAsync_1.emptyAsync(), source)
                    ]];
            }
        });
    });
}
exports.breakAsync = breakAsync;
