"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
/**
 * Creates an [[Iterable]] that repeats the provided value forever.
 *
 * @param value The value for each element of the [[Iterable]].
 * @category Query
 */
function continuous(value) {
    return new ContinuousIterable(value);
}
exports.continuous = continuous;
var ContinuousIterable = /** @class */ (function () {
    function ContinuousIterable(value) {
        this._value = value;
    }
    ContinuousIterable.prototype[Symbol.iterator] = function () {
        var value;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    value = this._value;
                    _a.label = 1;
                case 1: return [4 /*yield*/, value];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    ContinuousIterable = tslib_1.__decorate([
        internal_1.ToStringTag("ContinuousIterable")
    ], ContinuousIterable);
    return ContinuousIterable;
}());
