"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
/**
 * Iterates over all of the elements in a [[Queryable]], ignoring the results.
 *
 * @param source A [[Queryable]] object.
 * @category Scalar
 */
function drain(source) {
    var e_1, _a;
    internal_1.assert.mustBeQueryable(source, "source");
    try {
        for (var _b = tslib_1.__values(internal_1.ToIterable(source)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _1 = _c.value;
            ;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
}
exports.drain = drain;
