"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
function expand(source, projection) {
    internal_1.assert.mustBeQueryable(source, "source");
    internal_1.assert.mustBeFunction(projection, "projection");
    return internal_1.FlowHierarchy(new ExpandIterable(internal_1.ToIterable(source), projection), source);
}
exports.expand = expand;
var ExpandIterable = /** @class */ (function () {
    function ExpandIterable(source, projection) {
        this._source = source;
        this._projection = projection;
    }
    ExpandIterable.prototype[Symbol.iterator] = function () {
        var e_1, _a, projection, queue, source, source_1, source_1_1, element, e_1_1;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    projection = this._projection;
                    queue = [this._source];
                    _b.label = 1;
                case 1:
                    if (!queue.length) return [3 /*break*/, 10];
                    source = queue.shift();
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 7, 8, 9]);
                    source_1 = tslib_1.__values(source), source_1_1 = source_1.next();
                    _b.label = 3;
                case 3:
                    if (!!source_1_1.done) return [3 /*break*/, 6];
                    element = source_1_1.value;
                    queue.push(internal_1.ToIterable(projection(element)));
                    return [4 /*yield*/, element];
                case 4:
                    _b.sent();
                    _b.label = 5;
                case 5:
                    source_1_1 = source_1.next();
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 9];
                case 7:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 9];
                case 8:
                    try {
                        if (source_1_1 && !source_1_1.done && (_a = source_1.return)) _a.call(source_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 9: return [3 /*break*/, 1];
                case 10: return [2 /*return*/];
            }
        });
    };
    ExpandIterable = tslib_1.__decorate([
        internal_1.ToStringTag("ExpandIterable")
    ], ExpandIterable);
    return ExpandIterable;
}());
