"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
/**
 * Creates an [[Iterable]] for the own property entries of an `object`.
 *
 * @param source An `object`.
 * @category Query
 */
function objectEntries(source) {
    internal_1.assert.mustBeObject(source, "source");
    return new ObjectEntriesIterable(source);
}
exports.objectEntries = objectEntries;
var ObjectEntriesIterable = /** @class */ (function () {
    function ObjectEntriesIterable(source) {
        this._source = source;
    }
    ObjectEntriesIterable.prototype[Symbol.iterator] = function () {
        var e_1, _a, source, _b, _c, key, e_1_1;
        return tslib_1.__generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    source = this._source;
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 6, 7, 8]);
                    _b = tslib_1.__values(Object.keys(source)), _c = _b.next();
                    _d.label = 2;
                case 2:
                    if (!!_c.done) return [3 /*break*/, 5];
                    key = _c.value;
                    return [4 /*yield*/, [key, source[key]]];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    _c = _b.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_1_1 = _d.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 8: return [2 /*return*/];
            }
        });
    };
    ObjectEntriesIterable = tslib_1.__decorate([
        internal_1.ToStringTag("ObjectEntriesIterable")
    ], ObjectEntriesIterable);
    return ObjectEntriesIterable;
}());
