"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
/**
 * Creates an [[Iterable]] for the own property keys of an `object`.
 *
 * @param source An `object`.
 * @category Query
 */
function objectKeys(source) {
    internal_1.assert.mustBeObject(source, "source");
    return new ObjectKeysIterable(source);
}
exports.objectKeys = objectKeys;
var ObjectKeysIterable = /** @class */ (function () {
    function ObjectKeysIterable(source) {
        this._source = source;
    }
    ObjectKeysIterable.prototype[Symbol.iterator] = function () {
        var source;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    source = this._source;
                    return [5 /*yield**/, tslib_1.__values(Object.keys(source))];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    };
    ObjectKeysIterable = tslib_1.__decorate([
        internal_1.ToStringTag("ObjectKeysIterable")
    ], ObjectKeysIterable);
    return ObjectKeysIterable;
}());
