"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
/**
 * Creates an [[AsyncIterable]] for the own property keys of an `object`.
 *
 * @param source An `object` or a [[Promise]] for an `object`.
 * @category Query
 */
function objectKeysAsync(source) {
    internal_1.assert.mustBeObject(source, "source");
    return new AsyncObjectKeysIterable(source);
}
exports.objectKeysAsync = objectKeysAsync;
var AsyncObjectKeysIterable = /** @class */ (function () {
    function AsyncObjectKeysIterable(source) {
        this._source = source;
    }
    AsyncObjectKeysIterable.prototype[Symbol.asyncIterator] = function () {
        return tslib_1.__asyncGenerator(this, arguments, function _a() {
            var source;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, tslib_1.__await(this._source)];
                    case 1:
                        source = _a.sent();
                        internal_1.assert.mustBeObject(source, "source");
                        return [5 /*yield**/, tslib_1.__values(tslib_1.__asyncDelegator(tslib_1.__asyncValues(Object.keys(source))))];
                    case 2: return [4 /*yield*/, tslib_1.__await.apply(void 0, [_a.sent()])];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AsyncObjectKeysIterable = tslib_1.__decorate([
        internal_1.ToStringTag("AsyncObjectKeysIterable")
    ], AsyncObjectKeysIterable);
    return AsyncObjectKeysIterable;
}());
