"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
/**
 * Creates an [[AsyncIterable]] for the own property values of an `object`.
 *
 * @param source An `object` or a [[Promise]] for an `object`.
 * @category Query
 */
function objectValuesAsync(source) {
    internal_1.assert.mustBeObject(source, "source");
    return new AsyncObjectValuesIterable(source);
}
exports.objectValuesAsync = objectValuesAsync;
var AsyncObjectValuesIterable = /** @class */ (function () {
    function AsyncObjectValuesIterable(source) {
        this._source = source;
    }
    AsyncObjectValuesIterable.prototype[Symbol.asyncIterator] = function () {
        return tslib_1.__asyncGenerator(this, arguments, function _a() {
            var e_1, _a, source, _b, _c, key, e_1_1;
            return tslib_1.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, tslib_1.__await(this._source)];
                    case 1:
                        source = _d.sent();
                        internal_1.assert.mustBeObject(source, "source");
                        _d.label = 2;
                    case 2:
                        _d.trys.push([2, 8, 9, 10]);
                        _b = tslib_1.__values(Object.keys(source)), _c = _b.next();
                        _d.label = 3;
                    case 3:
                        if (!!_c.done) return [3 /*break*/, 7];
                        key = _c.value;
                        return [4 /*yield*/, tslib_1.__await(source[key])];
                    case 4: return [4 /*yield*/, _d.sent()];
                    case 5:
                        _d.sent();
                        _d.label = 6;
                    case 6:
                        _c = _b.next();
                        return [3 /*break*/, 3];
                    case 7: return [3 /*break*/, 10];
                    case 8:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 10];
                    case 9:
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    AsyncObjectValuesIterable = tslib_1.__decorate([
        internal_1.ToStringTag("AsyncObjectValuesIterable")
    ], AsyncObjectValuesIterable);
    return AsyncObjectValuesIterable;
}());
