"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
/**
 * Creates an [[AsyncIterable]] over a single element.
 *
 * @param value The only element for the [[AsyncIterable]].
 * @category Query
 */
function onceAsync(value) {
    return new AsyncOnceIterable(value);
}
exports.onceAsync = onceAsync;
var AsyncOnceIterable = /** @class */ (function () {
    function AsyncOnceIterable(value) {
        this._value = value;
    }
    AsyncOnceIterable.prototype[Symbol.asyncIterator] = function () {
        return tslib_1.__asyncGenerator(this, arguments, function _a() {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, tslib_1.__await(this._value)];
                    case 1: return [4 /*yield*/, _a.sent()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AsyncOnceIterable = tslib_1.__decorate([
        internal_1.ToStringTag("AsyncOnceIterable")
    ], AsyncOnceIterable);
    return AsyncOnceIterable;
}());
