"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
function skipRight(source, count) {
    internal_1.assert.mustBeQueryable(source, "source");
    internal_1.assert.mustBePositiveFiniteNumber(count, "count");
    return internal_1.FlowHierarchy(new SkipRightIterable(internal_1.ToIterable(source), count), source);
}
exports.skipRight = skipRight;
var SkipRightIterable = /** @class */ (function () {
    function SkipRightIterable(source, count) {
        this._source = source;
        this._count = count;
    }
    SkipRightIterable.prototype[Symbol.iterator] = function () {
        var e_1, _a, pending, count, _b, _c, element, e_1_1;
        return tslib_1.__generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    pending = [];
                    count = this._count;
                    if (!(count <= 0)) return [3 /*break*/, 2];
                    return [5 /*yield**/, tslib_1.__values(this._source)];
                case 1:
                    _d.sent();
                    return [3 /*break*/, 9];
                case 2:
                    _d.trys.push([2, 7, 8, 9]);
                    _b = tslib_1.__values(this._source), _c = _b.next();
                    _d.label = 3;
                case 3:
                    if (!!_c.done) return [3 /*break*/, 6];
                    element = _c.value;
                    pending.push(element);
                    if (!(pending.length > count)) return [3 /*break*/, 5];
                    return [4 /*yield*/, pending.shift()];
                case 4:
                    _d.sent();
                    _d.label = 5;
                case 5:
                    _c = _b.next();
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 9];
                case 7:
                    e_1_1 = _d.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 9];
                case 8:
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 9: return [2 /*return*/];
            }
        });
    };
    SkipRightIterable = tslib_1.__decorate([
        internal_1.ToStringTag("SkipRightIterable")
    ], SkipRightIterable);
    return SkipRightIterable;
}());
