"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var internal_1 = require("../internal");
function skipRightAsync(source, count) {
    internal_1.assert.mustBeAsyncQueryable(source, "source");
    internal_1.assert.mustBePositiveFiniteNumber(count, "count");
    return internal_1.FlowHierarchy(new AsyncSkipRightIterable(internal_1.ToPossiblyAsyncIterable(source), count), source);
}
exports.skipRightAsync = skipRightAsync;
var AsyncSkipRightIterable = /** @class */ (function () {
    function AsyncSkipRightIterable(source, count) {
        this._source = source;
        this._count = count;
    }
    AsyncSkipRightIterable.prototype[Symbol.asyncIterator] = function () {
        return tslib_1.__asyncGenerator(this, arguments, function _a() {
            var e_1, _a, pending, count, _b, _c, element, e_1_1;
            return tslib_1.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        pending = [];
                        count = this._count;
                        if (!(count <= 0)) return [3 /*break*/, 3];
                        return [5 /*yield**/, tslib_1.__values(tslib_1.__asyncDelegator(tslib_1.__asyncValues(this._source)))];
                    case 1: return [4 /*yield*/, tslib_1.__await.apply(void 0, [_d.sent()])];
                    case 2:
                        _d.sent();
                        return [3 /*break*/, 16];
                    case 3:
                        _d.trys.push([3, 10, 11, 16]);
                        _b = tslib_1.__asyncValues(this._source);
                        _d.label = 4;
                    case 4: return [4 /*yield*/, tslib_1.__await(_b.next())];
                    case 5:
                        if (!(_c = _d.sent(), !_c.done)) return [3 /*break*/, 9];
                        element = _c.value;
                        pending.push(element);
                        if (!(pending.length > count)) return [3 /*break*/, 8];
                        return [4 /*yield*/, tslib_1.__await(pending.shift())];
                    case 6: return [4 /*yield*/, _d.sent()];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8: return [3 /*break*/, 4];
                    case 9: return [3 /*break*/, 16];
                    case 10:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 16];
                    case 11:
                        _d.trys.push([11, , 14, 15]);
                        if (!(_c && !_c.done && (_a = _b.return))) return [3 /*break*/, 13];
                        return [4 /*yield*/, tslib_1.__await(_a.call(_b))];
                    case 12:
                        _d.sent();
                        _d.label = 13;
                    case 13: return [3 /*break*/, 15];
                    case 14:
                        if (e_1) throw e_1.error;
                        return [7 /*endfinally*/];
                    case 15: return [7 /*endfinally*/];
                    case 16: return [2 /*return*/];
                }
            });
        });
    };
    AsyncSkipRightIterable = tslib_1.__decorate([
        internal_1.ToStringTag("AsyncSkipRightIterable")
    ], AsyncSkipRightIterable);
    return AsyncSkipRightIterable;
}());
