/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query" */
export declare class Lazy<T> {
    private _value;
    private _factory;
    private _args;
    private constructor();
    static from<T, A extends any[]>(factory: (...args: A) => T, ...args: A): Lazy<T>;
    static for<T>(value: T): Lazy<T>;
    readonly hasValue: boolean;
    readonly value: T;
}
