"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const internal_1 = require("../internal");
function defaultIfEmptyAsync(source, defaultValue) {
    internal_1.assert.mustBeAsyncQueryable(source, "source");
    return internal_1.FlowHierarchy(new AsyncDefaultIfEmptyIterable(internal_1.ToPossiblyAsyncIterable(source), defaultValue), source);
}
exports.defaultIfEmptyAsync = defaultIfEmptyAsync;
let AsyncDefaultIfEmptyIterable = class AsyncDefaultIfEmptyIterable {
    constructor(source, defaultValue) {
        this._source = source;
        this._defaultValue = defaultValue;
    }
    [Symbol.asyncIterator]() {
        return tslib_1.__asyncGenerator(this, arguments, function* _a() {
            var e_1, _a;
            const source = this._source;
            const defaultValue = this._defaultValue;
            let hasElements = false;
            try {
                for (var source_1 = tslib_1.__asyncValues(source), source_1_1; source_1_1 = yield tslib_1.__await(source_1.next()), !source_1_1.done;) {
                    const value = source_1_1.value;
                    hasElements = true;
                    yield yield tslib_1.__await(value);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (source_1_1 && !source_1_1.done && (_a = source_1.return)) yield tslib_1.__await(_a.call(source_1));
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (!hasElements) {
                yield yield tslib_1.__await(defaultValue);
            }
        });
    }
};
AsyncDefaultIfEmptyIterable = tslib_1.__decorate([
    internal_1.ToStringTag("AsyncDefaultIfEmptyIterable")
], AsyncDefaultIfEmptyIterable);
