/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
import { Queryable } from "../types";
/**
 * Creates a subquery containing the cumulative results of applying the provided callback to each element.
 *
 * @param source A [[Queryable]] object.
 * @param accumulator The callback used to compute each result.
 * @category Subquery
 */
export declare function scan<T>(source: Queryable<T>, accumulator: (current: T, element: T, offset: number) => T): Iterable<T>;
/**
 * Creates a subquery containing the cumulative results of applying the provided callback to each element.
 *
 * @param source A [[Queryable]] object.
 * @param accumulator The callback used to compute each result.
 * @param seed An optional seed value.
 * @category Subquery
 */
export declare function scan<T, U>(source: Queryable<T>, accumulator: (current: U, element: T, offset: number) => U, seed: U): Iterable<U>;
