/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
import { Queryable, HierarchyIterable } from "../types";
/**
 * Lazily invokes a callback as each element of the iterable is iterated.
 *
 * @param source A [[Queryable]] object.
 * @param callback The callback to invoke.
 * @category Subquery
 */
export declare function tap<TNode, T extends TNode>(source: HierarchyIterable<TNode, T>, callback: (element: T, offset: number) => void): HierarchyIterable<TNode, T>;
/**
 * Lazily invokes a callback as each element of the iterable is iterated.
 *
 * @param source A [[Queryable]] object.
 * @param callback The callback to invoke.
 * @category Subquery
 */
export declare function tap<T>(source: Queryable<T>, callback: (element: T, offset: number) => void): Iterable<T>;
